from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.ChoiceBox import ChoiceBox
from Screens.Console import Console
from Screens.Standby import TryQuitMainloop
from Components.About import about
from Components.ActionMap import ActionMap
from Components.config import config, configfile, ConfigYesNo, ConfigSubsection, getConfigListEntry, ConfigSelection, ConfigNumber, ConfigText, ConfigInteger
from Components.ConfigList import ConfigListScreen
from Components.Sources.Progress import Progress
#from Components.Converter.EGWeather2 import *
from Tools.Downloader import downloadWithProgress
from Components.Sources.StaticText import StaticText
from Components.Label import Label
from Components.Pixmap import Pixmap, MovingPixmap
from Components.AVSwitch import AVSwitch
from twisted.web.client import getPage
from Tools.Directories import fileExists
import os
from enigma import ePicLoad
config.plugins.cobaltFHD = ConfigSubsection()
config.plugins.cobaltFHD = ConfigSubsection()
config.plugins.cobaltFHD.SecondInfobarStyle = ConfigSelection(default='baza2', choices=[
 ('baza2', _('Default')),
 ('baza22', _('ExtraInfobar_Chmura')),
 ('baza222', _('ExtraInfobar_2_airly')),
 ('baza2222', _('ExtraInfobar_3')),
 ('baza22222', _('ExtraInfobar_4')),
 ('baza222222', _('ExtraInfobar_6')),
 ('baza2222222', _('ExtraInfobar_airly')),
 ('baza22222222', _('ExtraInfobar_full')),
 ('baza222222222', _('ExtraInfobar_Poster')),
 ('baza2222222222',_('ExtraInfobar_Fhroma'))])
config.plugins.cobaltFHD.InfobarStyle = ConfigSelection(default='baza0', choices=[
 ('baza0', _('Default')),
 ('baza01', _('Chmurka')),
 ('baza02', _('infobar_1')),
 ('baza03', _('infobar_2')),
 ('baza04', _('infobar_2_Pogoda')),
 ('baza05', _('infobar_3_Pogoda')),
 ('baza06', _('infobar_3_Pogoda_airly')),
 ('baza07', _('infobar_4')),
 ('baza08', _('infobar_5')),
 ('baza09', _('infobar_6')),
 ('baza10', _('infobar_6_Chmura')),
 ('baza11', _('infobar_2_simple')),
 ('baza12', _('infobar_3_pogoda_airly2')),
 ('baza13', _('infobar_6_Chmura_no_animation')),
 ('baza14', _('infobar_Fhroma'))])
config.plugins.cobaltFHD.ChannSelector = ConfigSelection(default='no', choices=[
 ('no', _('Default')),
 ('no1', _('ChannelSelection_1')),
 ('no2', _('ChannelSelection_2')),
 ('no3', _('ChannelSelection_2_1')),
 ('no4', _('ChannelSelection_3')),
 ('no5', _('ChannelSelection_4')),
 ('no6', _('ChannelSelection_5')),
 ('no7', _('ChannelSelection_full')),
 ('no8', _('ChannelSelection_lewa')),
 ('no9', _('ChannelSelection_lewa_2')),
 ('no10', _('ChannelSelection_lewa_3')),
 ('no11', _('ChannelSelection_masterpicon'))])
config.plugins.cobaltFHD.EventSelector = ConfigSelection(default='ev', choices=[
 ('ev', _('Default')),
 ('ev1', _('EPGSelection'))])
config.plugins.cobaltFHD.FontStyle = ConfigSelection(default='basic', choices=[
 ('basic', _('Default')),
 ('dr', _('DroidSans')),
 ('arm', _('Army_Regular_L')),
 ('rob', _('Roboto'))])
version = 'CobaltFHD'
config.plugins.cobaltFHD.skinSelector = ConfigSelection(default='base', choices=[
 ('base', _('Default'))])
config.plugins.cobaltFHD.colorSelector = ConfigSelection(default='head', choices=[
 ('head', _('Default')),
 ('cyan', _('Cyan')),
 ('green', _('Green')),
 ('jasny', _('Jasny')),
 ('lemon', _('Lemon'))])
config.plugins.cobaltFHD.VolumeSelector = ConfigSelection(default='vol', choices=[
 ('vol', _('Default')),
 ('vol1', _('Volume_1'))])
config.plugins.cobaltFHD.ShoutcastSelector = ConfigSelection(default='shout', choices=[
 ('shout', _('Default')),
 ('shout1', _('Shoutcast'))])
config.plugins.cobaltFHD.NeobootSelector = ConfigSelection(default='neo', choices=[
 ('neo', _('Default')),
 ('neo1', _('Neoboot')),
 ('neo2', _('Neoboot_Pro'))])
config.plugins.cobaltFHD.MsnWeatherSelector = ConfigSelection(default='msn', choices=[
 ('msn', _('Default')),
 ('msn2', _('WeatherPlugin Big Icons')),
 ('msn1', _('WeatherPlugin Animation'))])
config.plugins.cobaltFHD.WeatherMsnSelector = ConfigSelection(default='wet', choices=[
 ('wet', _('Default')),
 ('wet1', _('Weather no animation'))])

 
 
def Plugins(**kwargs):
    return PluginDescriptor(name='CobaltFHD Configuration', description=_('Customization tool for CobaltFHD skin'), where=PluginDescriptor.WHERE_PLUGINMENU, icon='plugin.png', fnc=main)


def main(session, **kwargs):
    session.open(CobaltFHDSetup)


class CobaltFHDSetup(ConfigListScreen, Screen):
    skin = '<screen name="CobaltFHDSetup" position="center,center" size="1000,640" title="CobaltFHD Skin Controler">\n\t\t  <eLabel font="Regular; 24" foregroundColor="#00ff4A3C" halign="center" position="20,598" size="120,26" text="Cancel" />\n\t\t  <eLabel font="Regular; 24" foregroundColor="#0056C856" halign="center" position="220,598" size="120,26" text="Save" />\n\t\t  <widget name="config" font="Regular; 24" itemHeight="40" position="5,5" scrollbarMode="showOnDemand" size="990,550" />\n\t\t\n\t\t  </screen>'

    def __init__(self, session):
        self.version = '.CobaltFHD'
        Screen.__init__(self, session)
        self.session = session
        self.skinFile = '/usr/share/enigma2/CobaltFHD/skin.xml'
        self.previewFiles = '/usr/lib/enigma2/python/Plugins/Extensions/CobaltFHD/sample/'
        self.Scale = AVSwitch().getFramebufferScale()
        self.PicLoad = ePicLoad()
        self['Preview'] = Pixmap()
        list = []
        list.append(getConfigListEntry(_('InfoBar Style:'), config.plugins.cobaltFHD.InfobarStyle))
        list.append(getConfigListEntry(_('SecondInfobar Style:'), config.plugins.cobaltFHD.SecondInfobarStyle))
        list.append(getConfigListEntry(_('ChannelSelection Style:'), config.plugins.cobaltFHD.ChannSelector))
        list.append(getConfigListEntry(_('EventView Style:'), config.plugins.cobaltFHD.EventSelector))
        list.append(getConfigListEntry(_('Skin Style:'), config.plugins.cobaltFHD.skinSelector))                      
        list.append(getConfigListEntry(_('Select Your Font:'), config.plugins.cobaltFHD.FontStyle))
        list.append(getConfigListEntry(_('Color Style:'), config.plugins.cobaltFHD.colorSelector))
        list.append(getConfigListEntry(_('Volume Style:'), config.plugins.cobaltFHD.VolumeSelector))
        list.append(getConfigListEntry(_('Shoutcat Style:'), config.plugins.cobaltFHD.ShoutcastSelector))
        list.append(getConfigListEntry(_('Neoboot Style:'), config.plugins.cobaltFHD.NeobootSelector))
        list.append(getConfigListEntry(_('WeatherPlugin Style:'), config.plugins.cobaltFHD.MsnWeatherSelector))
        list.append(getConfigListEntry(_('WeatherMSN Style:'), config.plugins.cobaltFHD.WeatherMsnSelector))  
    
		
        ConfigListScreen.__init__(self, list)
        self['actions'] = ActionMap(['OkCancelActions',
         'DirectionActions',
         'InputActions',
         'ColorActions'], {'left': self.keyLeft,
         'down': self.keyDown,
         'up': self.keyUp,
         'right': self.keyRight,
         'red': self.keyExit,
         'green': self.keySave,
         'yellow': self.checkforUpdate,
         'blue': self.info,
         'cancel': self.keyExit}, -1)
        self.onLayoutFinish.append(self.UpdateComponents)

    def GetPicturePath(self):
        try:
            returnValue = self['config'].getCurrent()[1].value
            path = '/usr/lib/enigma2/python/Plugins/Extensions/CobaltFHD/screens/' + returnValue + '.jpg'
            return path
        except:
            return '/enigma2/python/Plugins/Extensions/CobaltFHD/screens/default.jpg'

    def UpdatePicture(self):
        self.PicLoad.PictureData.get().append(self.DecodePicture)
        self.onLayoutFinish.append(self.ShowPicture)

    def ShowPicture(self):
        self.PicLoad.setPara([self['Preview'].instance.size().width(),
         self['Preview'].instance.size().height(),
         self.Scale[0],
         self.Scale[1],
         0,
         1,
         '#002C2C39'])
        self.PicLoad.startDecode(self.GetPicturePath())

    def DecodePicture(self, PicInfo = ''):
        ptr = self.PicLoad.getData()
        self['Preview'].instance.setPixmap(ptr)

    def UpdateComponents(self):
        self.UpdatePicture()

    def info(self):
        aboutbox = self.session.open(MessageBox, _('CobaltFHD Configuration for Image'), MessageBox.TYPE_INFO)
        aboutbox.setTitle(_('Info...'))

    def keyLeft(self):
        ConfigListScreen.keyLeft(self)
        self.ShowPicture()

    def keyRight(self):
        ConfigListScreen.keyRight(self)
        self.ShowPicture()

    def keyDown(self):
        self['config'].instance.moveSelection(self['config'].instance.moveDown)
        self.ShowPicture()

    def keyUp(self):
        self['config'].instance.moveSelection(self['config'].instance.moveUp)
        self.ShowPicture()

    def restartGUI(self, answer):
        if answer is True:
            self.session.open(TryQuitMainloop, 3)
        else:
            self.close()

    def keySave(self):
        if not fileExists(self.skinFile + self.version):
            for x in self['config'].list:
                x[1].cancel()

            self.close()
            return
        for x in self['config'].list:
            x[1].save()

        try:
            skin_lines = []
            head_file = self.previewFiles + 'head-' + config.plugins.cobaltFHD.colorSelector.value + '.xml'
            skFile = open(head_file, 'r')
            head_lines = skFile.readlines()
            skFile.close()
            for x in head_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'secondinfobar-' + config.plugins.cobaltFHD.SecondInfobarStyle.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'channellist-' + config.plugins.cobaltFHD.ChannSelector.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            font_file = self.previewFiles + 'font-' + config.plugins.cobaltFHD.FontStyle.value + '.xml'
            skFile = open(font_file, 'r')
            font_lines = skFile.readlines()
            skFile.close()
            for x in font_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'volume-' + config.plugins.cobaltFHD.VolumeSelector.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'shout-' + config.plugins.cobaltFHD.ShoutcastSelector.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'neo-' + config.plugins.cobaltFHD.NeobootSelector.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'msn-' + config.plugins.cobaltFHD.MsnWeatherSelector.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'wet-' + config.plugins.cobaltFHD.WeatherMsnSelector.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'ev-' + config.plugins.cobaltFHD.EventSelector.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            skn_file = self.previewFiles + 'infobar-' + config.plugins.cobaltFHD.InfobarStyle.value + '.xml'
            skFile = open(skn_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

				
            base_file = self.previewFiles + 'base.xml'
            if config.plugins.cobaltFHD.skinSelector.value == 'base1':
                base_file = self.previewFiles + 'base1.xml'
            if config.plugins.cobaltFHD.skinSelector.value == 'base':
                base_file = self.previewFiles + 'base.xml'                            
            skFile = open(base_file, 'r')
            file_lines = skFile.readlines()
            skFile.close()
            for x in file_lines:
                skin_lines.append(x)

            xFile = open(self.skinFile, 'w')
            for xx in skin_lines:
                xFile.writelines(xx)

            xFile.close()
        except:
            self.session.open(MessageBox, _('Error by processing the skin file !!!'), MessageBox.TYPE_ERROR)

        restartbox = self.session.openWithCallback(self.restartGUI, MessageBox, _('GUI needs a restart to apply a new skin.\nDo you want to Restart the GUI now?'), MessageBox.TYPE_YESNO)
        restartbox.setTitle(_('Restart GUI now?'))

    def restartGUI(self, answer):
        if answer is True:
            self.session.open(TryQuitMainloop, 3)
        else:
            self.close()

    def checkforUpdate(self):
        try:
            getPage('http://').addCallback(self.gotUpdateInfo).addErrback(self.gotError)
        except Exception as error:
            print str(error)

    def gotError(self, error = ''):
        pass

    def gotUpdateInfo(self, html):
        tmp_infolines = html.splitlines()
        version_server = tmp_infolines[0]
        self.updateurl = tmp_infolines[1]
        if version_server == version:
            message = '%s %s\n%s %s\n\n%s' % (_('Wersja na Serwerze:'),
             version_server,
             _('Wersja zainstalowana:'),
             version,
             _('Posiadasz aktualna wersje cobaltFHD !'))
            self.session.open(MessageBox, message, MessageBox.TYPE_INFO)
        elif version_server > version:
            message = '%s %s\n%s %s\n\n%s' % (_('Wersja na Serwerze:'),
             version_server,
             _('Wersja zainstalowana:'),
             version,
             _('Aktualizacja jest dostepna!\n\nCzy chcesz uruchomic akutalizacje teraz?'))
            self.session.openWithCallback(self.update, MessageBox, message, MessageBox.TYPE_YESNO)
        else:
            self.session.open(MessageBox, _('Posiadasz eksperymentalna wersje beta !!!'), MessageBox.TYPE_ERROR)

    def update(self, answer):
        if answer is True:
            self.session.open(cobaltFHDUpdater, self.updateurl)
        else:
            return

    def keyExit(self):
        for x in self['config'].list:
            x[1].cancel()

        self.close()


class cobaltFHDUpdater(Screen):

    def __init__(self, session, updateurl):
        self.session = session
        self.updateurl = updateurl
        skin = '\n\t\t<screen name="CobaltFHDUpdater" position="center,center" size="840,360" flags="wfNoBorder" backgroundColor="background">\n\t\t\t<widget name="status" position="20,10" size="800,70" transparent="1" font="Regular;16" foregroundColor="foreground" backgroundColor="background" valign="center" halign="left" noWrap="1" />\n\t\t\t<widget source="progress" render="Progress" position="100,153" size="400,6" transparent="1" borderWidth="0" />\n\t\t\t<widget source="progresstext" render="Label" position="333,184" zPosition="2" font="Regular;18" halign="center" transparent="1" size="180,20" foregroundColor="foreground" backgroundColor="background" />\n\t\t</screen>'
        self.skin = skin
        Screen.__init__(self, session, updateurl)
        self['status'] = Label()
        self['progress'] = Progress()
        self['progresstext'] = StaticText()
        self.startUpdate()

    def startUpdate(self):
        self['status'].setText(_('Downloading cobaltFHD...'))
        self.dlfile = '/tmp/xxx.tar.gz'
        self.download = downloadWithProgress(self.updateurl, self.dlfile)
        self.download.addProgress(self.downloadProgress)
        self.download.start().addCallback(self.downloadFinished).addErrback(self.downloadFailed)

    def downloadFinished(self, string = ''):
        self['status'].setText(_('Instalowanie aktualizacji!'))
        os.system('cd /tmp/; tar -xzvf xxx*.tar.gz -C /; sync')
        os.system('rm /tmp/xxx*.*')
        os.system('sync')
        restartbox = self.session.openWithCallback(self.restartGUI, MessageBox, _('CobaltFHD zostal zaktualizowany!!!\nCzy chcesz zrestartowac GUI teraz?'), MessageBox.TYPE_YESNO)
        restartbox.setTitle(_('Restart GUI now?'))

    def downloadFailed(self, failure_instance = None, error_message = ''):
        text = _('Blad pobierania plikow!')
        if error_message == '' and failure_instance is not None:
            error_message = failure_instance.getErrorMessage()
            text += ': ' + error_message
        self['status'].setText(text)
        return

    def downloadProgress(self, recvbytes, totalbytes):
        self['progress'].value = int(100 * recvbytes / float(totalbytes))
        self['progresstext'].text = '%d of %d kBytes (%.2f%%)' % (recvbytes / 1024, totalbytes / 1024, 100 * recvbytes / float(totalbytes))

    def restartGUI(self, answer):
        if answer is True:
            self.session.open(TryQuitMainloop, 3)
        else:
            self.close()
